/*--------------------------------
 * 
 * Jerome.Gouzy@toulouse.inra.fr
 * Created: 20140120
 * 
 * $Id: paramparser.h 475 2015-12-28 15:51:57Z gouzy $
 * 
 ---------------------------------*/
#ifndef PARAMPARSER_H

#define PARAMPARSER_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include "uthash.h"
#include "dirent.h"
#include "assert.h"
#include "general.h"

#define LOFMAXFILES 1000

typedef char* lof_t[LOFMAXFILES];


typedef struct paramparser  {
	char *key;
	char *value;
	char type;
	UT_hash_handle hh;         /* makes this structure hashable */
} paramparser_t;

void ParamParserInitLof(lof_t lof);

void ParamParserPrintCli(int argc,char *argv[],FILE *out,char *);
void ParamParserSetUnlessDefined(paramparser_t **,const char *,const char *);
void ParamParserDump(paramparser_t *,FILE *);
char *itoa(long value,char *);
char *ftoa(double value,char *);
int  ParamParserIsDefined(paramparser_t **,const char *);
void ParamParserAssertDefined(paramparser_t **,const char *);
void  ParamParserSet(paramparser_t **,const char *,const char *);
char *ParamParserGet(paramparser_t **,const char *);

void ParamParserAssertDirExists(paramparser_t **,const char *);
void ParamParserAssertFileExists(paramparser_t **,const char *);
void ParamParserAssertInteger(paramparser_t **,const char *);
void ParamParserDeleteListOfFiles(paramparser_t **pp,lof_t lof);
void ParamParserDelete(paramparser_t **pp);

void  ParamParserSetType(paramparser_t **pp,const char *key,char type);

int ParamParserGetListOfFiles(paramparser_t **pp,const char *key,lof_t lof);

void ParamParserInit(paramparser_t **pp,int argc,char **argv,char *str_getopt);

extern void Usage(char *argv[]);

#endif
